// 
//

#include "stdafx.h"
#include "MyHash.h"
#include "chx.h"

static WCHAR* malloc_char2wchar(char* pszStr);
static DWORD ReadCounter(char* pszName, BOOL bIncrement);
static int QueryValueString( char* pszSrc, char* pszKey, char* pszOutStr, int nOutStrLen );
static int GetQueryValueInt(char* pszSrc, char* pszKey);
static BOOL GetScriptCurrentDir(MyHash* pEnv, char* pszDstName, int nDstNameLen);

// ----------------------------------------------------------------------------
int fnChx(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	WCHAR wszPath[MAX_PATH] = {0};
	char szBuf[MAX_PATH] = {0};
	WCHAR wszImageFile[32] = {0};
	int nFigure = 0;
	char szName[32] = {0};
	DWORD	dwCount = 0;
	DWORD	dw1stfigure = 0;
	char* pQS = NULL;
	
	// return GIF file
	pRes->Add( "Content-Type: image/gif\r\n\r\n" );

	pQS = pEnv->GetValue( "QUERY_STRING" );
	if( pQS )
	{
		// get figure
		nFigure = GetQueryValueInt( pQS, "figure" );
	}

	if( 0 == QueryValueString( pQS, "name", szName, 32 ) )
	{
		// Get counter name
		strcpy( szName, "default" );
	}

	dwCount = ReadCounter( szName, nFigure == 1 ? TRUE : FALSE );

	// error check
	if( nFigure > 10 && nFigure < 1 )
	{
		nFigure = 1;
	}

	// Get 1st figure's number
	dw1stfigure = dwCount %10;

	if( dw1stfigure == 9 && nFigure > 1 )
		dwCount++;

	// Get current figure's number
	for( int ii = 0; ii < nFigure -1; ii++ ) dwCount /= 10;
	dwCount %= 10;

	//if( nFigure == 2 && dw1stfigure == 9 )
	//	dwCount++;

	wsprintf( wszImageFile, L"counter%d.gif", dwCount );

	GetScriptCurrentDir( pEnv, szBuf, MAX_PATH );
	WCHAR* pwstr = malloc_char2wchar( szBuf );

	if( pwstr == NULL )
		return pRes->GetLength();

	wcscpy( wszPath, pwstr );
	free( pwstr );
	wcscat( wszPath, wszImageFile );

	HANDLE hFile = CreateFile( wszPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL );

	if( hFile == INVALID_HANDLE_VALUE )
	{
		return pRes->GetLength();
	}

	char szBodyBuf[256];
	DWORD dwReadBytes;
	do
	{
		if( ReadFile( hFile, szBodyBuf, 256, &dwReadBytes, NULL ) )
		{
			if( dwReadBytes == 0 )
			{
				break;
			}

			pRes->Add( szBodyBuf, dwReadBytes );
		}
		else
		{
			break;
		}
	}while( dwReadBytes > 0 );

	CloseHandle( hFile );

	return pRes->GetLength();
}

// ----------------------------------------------------------------------------
static WCHAR* malloc_char2wchar(char* pszStr)
{
	WCHAR* pwsRet = NULL;
	int nRet = 0;

	nRet = MultiByteToWideChar(CP_ACP,0,pszStr,-1,NULL,0);

	if( nRet == 0 )
	{
		return NULL;
	}

	pwsRet = (WCHAR*)malloc( nRet * sizeof(WCHAR) );

	if( 0 == MultiByteToWideChar(CP_ACP,0,pszStr,-1,pwsRet,nRet) )
	{
		free( pwsRet );
		return NULL;
	}

	return pwsRet;

}

// ----------------------------------------------------------------------------
static DWORD ReadCounter(char* pszName, BOOL bIncrement)
{
	WCHAR*	pszSubKey = _T("SOFTWARE\\ISHISOFT\\COUNTER");
	WCHAR*	pszValueName = malloc_char2wchar(pszName);
	if( pszValueName == NULL )
		return 0;

	HKEY	hKey;
	DWORD	dwType	= REG_DWORD;
	DWORD	dwRet	= 0;
	LONG	lErr;
	DWORD	dwValueSize = sizeof(DWORD);

	// Open the key
	lErr = RegOpenKeyEx(HKEY_LOCAL_MACHINE, pszSubKey, 0, KEY_QUERY_VALUE, &hKey);

	if( lErr != ERROR_SUCCESS )
	{
		// When first of reading, make key and value.
		lErr = RegCreateKeyEx(
			HKEY_LOCAL_MACHINE, pszSubKey, 0, TEXT(""), 0, 0, NULL, &hKey, &dwRet);
		if( lErr != ERROR_SUCCESS )
		{
			RegCloseKey(hKey);
			free(pszValueName);
			return 0;
		}
	
		DWORD dwStart = 0;
		RegSetValueEx( hKey, pszValueName, 1, dwType, (const BYTE*)&dwStart, dwValueSize); 
		RegCloseKey(hKey);
		free(pszValueName);
		return 1;
	}

	DWORD	dwQuery = 0;
	lErr = RegQueryValueEx(hKey, pszValueName, NULL, &dwType, (LPBYTE)&dwQuery, &dwValueSize);
	if( bIncrement ) 
	{
		dwQuery++;
		lErr = RegSetValueEx( hKey, pszValueName, 1, dwType, (const BYTE*)&dwQuery, dwValueSize); 
	}

	RegCloseKey(hKey);
	free(pszValueName);
	return dwQuery;
}

// ----------------------------------------------------------------------------
static int QueryValueString( char* pszSrc, char* pszKey, char* pszOutStr, int nOutStrLen )
{

	int	ii;

	if( pszSrc == NULL || pszOutStr == NULL )
		return 0;

	char* value = strstr( pszSrc, pszKey );

	if( NULL == value )
		return 0;
	
	char* tmp = value;
	while( *tmp++ != '=' );

	if( nOutStrLen == 0 )
	{
		for(ii = 0; *tmp != '&' && *tmp != '\0'; ii++, tmp++ );
		return ii;
	}

	for(ii = 0; *tmp != '&' && *tmp != '\0' && ii < nOutStrLen; ii++ )
	{
		pszOutStr[ii] = *tmp++;
	}
	pszOutStr[ii] = '\0';
	
	return ii;
}

// ----------------------------------------------------------------------------
static int GetQueryValueInt(char* pszSrc, char* pszKey)
{
	if( pszSrc == NULL || pszKey == NULL )
		return 0;
	char szOutInt[64];
	if( QueryValueString(pszSrc, pszKey, szOutInt, 64) )
		return atoi(szOutInt);
	else 
		return 0;
}

static BOOL GetScriptCurrentDir(MyHash* pEnv, char* pszDstName, int nDstNameLen)
{
	//SCRIPT_NAME=/scripts/sample.chx
	//DOCUMENT_ROOT=\wwwroot

	char* pszDocmentRoot = pEnv->GetValue("DOCUMENT_ROOT");
	char* pszScriptName = pEnv->GetValue("SCRIPT_NAME");

	if( !pszDocmentRoot || !pszScriptName )
		return FALSE;

	int nDocmentRoot = strlen(pszDocmentRoot);
	int nScriptName = strlen(pszScriptName);

	if( nDocmentRoot + nScriptName >= nDstNameLen )
		return FALSE;
	
	strcpy(pszDstName, pEnv->GetValue("DOCUMENT_ROOT"));
	strcat(pszDstName, pEnv->GetValue("SCRIPT_NAME"));

	char* p = pszDstName;

	do{
		if( *p == '/' )
			*p = '\\';
	}while( *p++ != '\0' );

	p--;

	while( *p != '\\' )
	{
		if( p == pszDstName ) break;

		*p-- = '\0';
	};

	return TRUE;
}

//*****************************************************************************
//
// DllMain
//
//*****************************************************************************
BOOL APIENTRY DllMain(
	HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

